unit hiMT_MultiMem;

interface

uses Kol,Share,Debug;

type
  THIMT_MultiMem = class(TDebug)
   private
    l: PList;
   public
    _prop_From:integer;
    _prop_Count:integer;

    _event_onData:THI_Event;

    constructor Create;
    procedure _work_doValue(var _Data:TData; Index:word);
    procedure _work_doClear(var _Data:TData; Index:word);
    procedure Value(var _Data:TData; Index:word);
  end;

implementation

procedure THIMT_MultiMem._work_doValue;
var i:integer;
    p,pn:PData;
begin
  _work_doClear(_data,index);
  p:=@_data;
  for i:=0 to _prop_From+_prop_Count do begin
    if i>=_prop_from then begin
       new(pn);
       dtData(pn^,p^);
       l.add(pn);
    end;
    if p.ldata=nil then break;
    p:=p.ldata;
  end;
  _hi_CreateEvent(_Data,@_event_onData,_Data);
end;

procedure THIMT_MultiMem._work_doClear;
var i:integer;
begin
  if l.count>0 then begin
    for i:=0 to l.count-1 do dispose(PData(l.items[i]));
    l.clear;
  end;
end;

procedure THIMT_MultiMem.Value;
begin
  if index<l.count then dtData(_data,PData(l.items[index])^);
end;

constructor THIMT_MultiMem.Create;
begin
   inherited Create;
   l:=NewList;
end;

end.
